function [THETA PCovariant] = RLS(U, Y, PCovariant0, THETA0, lambda)

  PHI = [-Y(end-1) -Y(end-2) -Y(end-3) U(end-1) U(end-2) U(end-3)]';
  EPS = Y(end) - PHI'*THETA0;                               % epsilon       
  K = (PCovariant0*PHI) / (lambda + PHI'*PCovariant0*PHI);  % correction
  PCovariant = (1 / lambda) * (PCovariant0 - K*PHI'*PCovariant0); % update
  THETA = THETA0 + K*EPS; 

end